<?php
/**
 * Copyright  (c) 2015, Till Wehowski
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *    This product includes software developed by the frdl/webfan.
 * 4. Neither the name of frdl/webfan nor the
 *    names of its contributors may be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY frdl/webfan ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL frdl/webfan BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 *     
 *   @vendor     frdl
 *   @package    webfan Application Composer Backend
 *   @filename   webfan.fexe.php
 *   @todo
 * 
 *   @state:     test/development
 *  
 * 
 */
namespace frdl\xGlobal; 

/* BEGIN CONFIGSECTION */
error_reporting(E_ALL);
ini_set('display_errors', 1);
/* END CONFIGSECTION */

/* BEGIN BOOTSECTION   */
if(!class_exists('\frdl\webfan\App')){
	
 if(!defined( __NAMESPACE__.'\\'.'__BOOTFILE__')) {
 	define( __NAMESPACE__.'\\'.'__BOOTFILE__', __DIR__ . DIRECTORY_SEPARATOR . '..'.DIRECTORY_SEPARATOR .'..'.DIRECTORY_SEPARATOR .'..'.DIRECTORY_SEPARATOR . 'bootstrap.php');
 }


 if(!in_array( __BOOTFILE__, get_included_files())){
 	
  if(!file_exists(  __BOOTFILE__)){
	$str = 'App '.basename(__FILE__).' is not installed cortrectly! File ' .__BOOTFILE__.' not found. 
	<br />
	Please read <a target="_blank" href="https://github.com/frdl/webfan/wiki/Installation">Installation instruction</a>!';
	trigger_error($str, E_USER_ERROR);
	echo $str; 
	die();
  }
 	
 	require  __BOOTFILE__;
 }
 
}
 
 if(!class_exists('\frdl\webfan\App')){
 	$str = 'App '.basename(__FILE__).' is not installed cortrectly! Class \frdl\webfan\App not found. 
	<br />
	Please read <a target="_blank" href="https://github.com/frdl/webfan/wiki/Installation">Installation instruction</a>!';
	trigger_error($str, E_USER_ERROR);
	echo $str; 
	die();	
 }
 
 
/* END BOOTSECTION */ 

 
   
class webfan extends fexe    
{
	 const DEL='µ';
     const CMD = 'cmd';
	 
	 const HINT_NOTINSTALLED = 'The Program frdl/webfan is not installed properly, try to install via {___$$URL_INSTALLER_HTMLPAGE$$___}!';
	 
	 const DIR_PLUGIN = '.1.3.6.1.4.1.37553.8.1.8.8.5.65';
	
	
	 protected $aSess;
	 
	 protected $debug = false;
	 
	 protected $Console;
	 
	 protected $isAdmin = false;
	 
	 protected static $_db = null;
	
	 
	 protected $ComponentsManager = null;
	 
	 
	function __construct($file = null, $file_offset = null, $e_level = E_USER_ERROR){
	  parent::__construct($file, $file_offset, $e_level);
	}	
	
	 public static function db(){

		return self::$_db;
	 }
	
	 public function Request(mixed $args = null){
	 	
	 }
   
   
     protected function writeToConfigFile(){
       if(!isset($this->data['CONFIGFILE']) || !file_exists($this->data['CONFIGFILE'])){
              return false;
	   }
    	$file = $this->data['CONFIGFILE'];
    	
 	    	
				$php = "<?php
			 			/*
			 			  - Do not edit this file manually! 
			 			  Application Composer - Config
			 			  Download: http://www.webfan.de/install/
			 			  
			 			*/
			 			    if(isset(\$this) &&
			 			      ( 
			 			            get_class(\$this) === '\\frdl\xGlobal\webfan' 
			 			         || is_subclass_of(\$this, '\\frdl\ApplicationComposer\Command\CMD')  
			 			         || get_class(\$this) === 'frdl\xGlobal\webfan' 
			 			         || is_subclass_of(\$this, 'frdl\ApplicationComposer\Command\CMD')
			 			      )){
                         	     \$this->data['config'] = ".var_export($this->data['config'], true).";								
							}		 			
                        ";
			 			
		try{
			chmod($file,0755);
		}	catch(\Exception $e){
			
		} 			
		if(false !== file_put_contents($file, $php))	 			{
		try{
			chmod($file,0644);
		}	catch(\Exception $e){
			
		} 				
			return true;
		}else{
			return false;
		}

			 			
   }
	   
   public function loadConfigFromFile($required = true){
	   $data = $this->data(); 
		 
		 
       if( (false !== $required && !isset($data['CONFIGFILE']) || !file_exists($data['CONFIGFILE']))){
              return false;
	   }
		 $file = $data['CONFIGFILE']; 
		 if(false !== $required){
		 	 require $file;
		 }else{
		 	 include $file;
		 }
		
 	 return true;
   }
   
   
	 
	 public function data(Array $data = null){
	 	

	 	 	
	 	
	 	
	  if(null === $this->data){

	   if(!isset($this->data))$this->data = array();
	   $this->data['DIR'] = getcwd() . DIRECTORY_SEPARATOR ; 
	   $this->data['CONFIGFILE'] = $this->data['DIR'].'config.frdl.php';
	   $this->data['o'] = new \stdclass;	   
	   $this->data['data_out'] = new \stdclass;
	   $this->data['config'] = array();
	   $this->data['settings'] = new \stdclass;
	   $this->data['settings']->cli = array(
	         'frdl' => array(
	             'cli.cmd.cli' => 'frdl',
	             'cli.class' => '\frdl\ApplicationComposer\Console',
	             'cli.class.required.parent' => '\frdl\aSQL\Engines\Terminal\CLI',
	         ),
	   );
	   
	   

	     
	     $this->data['tpl_data'] = array(
	          'FILE' => htmlentities(__FILE__),
	          'URI_DIR_API' => self::URI_DIR_API,
 	          'LOCATION' => 'http://'.$_SERVER['SERVER_NAME']
 	                         .implode('/', \webdof\wURI::getInstance()->getU()->dirs)
 	                         .'/'.\webdof\wURI::getInstance()->getU()->file,
 	          'URL' => '',
 	          'EXTRA_PMX_URL' => '',
 	          
	     );	   
	   
	   $h  = parse_url($this->data['tpl_data']['LOCATION']);
	   $pu = \webdof\wURI::parse_uri($h['scheme'], $h['host'], $h['path']);
	   $path = '/';
	   foreach($pu->dirs as $num => $dir){
	   	 $path.= $dir. '/';
	   }
	   $this->data['installed'] = false;
	   $this->data['index'] = 'Main Template';	

	 
	  
	   	   
	   if(is_array($data) || is_object($data)){
	   	 foreach($data as $k => $v){
		 	if(isset($this->data[$k]))$this->data[$k] = $v;
		 }
	   }
	
	  
	   \webfan\App::God()->{'?session_started'}(true);
//		   $sessionKey = __CLASS__. sha1( $h['host'] );
       $sessionKey=__CLASS__;
       if(!isset($_SESSION[$sessionKey]))$_SESSION[$sessionKey] = array();
       $this->aSess = & $_SESSION[$sessionKey] ;
        
        
         
       $this->data['config_new'] = $this->readFile('config.json');
       $this->data['config'] = $this->data['config_new'];
       if(file_exists($this->data['CONFIGFILE'])){
	   	  require $this->data['CONFIGFILE'];
	   	  $this->data['installed'] = "1";
	   }else{
	   	$this->data['installed'] = "0";
	   }
       $this->data['config_new'] = (array)$this->data['config_new'];        
       $this->data['config'] = array_merge($this->data['config_new'], (array)$this->data['config']);
       $this->data['config']['INSTALLED'] = $this->data['installed'];

       

       
       
       if(base64_decode('eyRfX0xPQ0FUSU9OX19ffQ==') === $this->data['config']['URL'] ){
	   	   $this->data['config']['URL'] = $this->data['tpl_data']['LOCATION'];
	   	  if(true === $this->debug) trigger_error(self::HINT_NOTINSTALLED, E_USER_WARNING);
	   }
       $this->data['tpl_data']['URL'] = &$this->data['config']['URL'];
       $this->data['tpl_data']['URL'] = str_replace('setup.phpsetup.php', 'setup.php', $this->data['tpl_data']['URL']);
       
       
	   $this->data['tpl_data']['URI_DIR_API'] =  $this->data['tpl_data']['URL'].'api.php';	
	   $this->data['config']['URL_API_ORIGINAL'] =  $this->data['tpl_data']['URI_DIR_API'];	
	   $this->data['config']['URL_API_ORIGINAL'] = str_replace('setup.phpapi.php', 'api.php', $this->data['config']['URL_API_ORIGINAL']);
       $this->data['tpl_data']['URI_DIR_API'] = str_replace('setup.phpapi.php', 'api.php', $this->data['tpl_data']['URI_DIR_API']);
   
   
 	    $this->data['tpl_data']['PACKAGE'] = function(){
 	       return $this->data['config']['PACKAGE'];
 	    };
 	    $this->data['tpl_data']['VERSION'] = function(){
 	       return $this->data['config']['VERSION'];
 	    }; 
 	    $this->data['tpl_data']['INSTALLED'] = function(){
 	       return $this->data['config']['INSTALLED'];
 	    }; 
 	    $this->data['tpl_data']['REGISTERED'] = function(){
 	       return $this->data['config']['REGISTERED'];
 	    }; 
  	    $this->data['tpl_data']['UNAME'] = function(){
 	       return $this->data['config']['UNAME'];
 	    }; 
  	    $this->data['tpl_data']['UID'] =  function(){
 	       return $this->data['config']['UID'];	  
 	    };   
         	
       $this->data['INSTALLER_PHAR_AVAILABLE'] = '0';
       $this->data['tpl_data']['EXTRA_PHAR_URL'] = '';
       $this->data['tpl_data']['INSTALLER'] = '';
	   if(   function_exists('frdl_install_rewrite_function')
	      || file_exists($this->data['DIR'] . 'install.phar') 
	      || file_exists($this->data['DIR'] . 'install.php') 	    
	    ){
	   	  $this->_installFromPhar( \webdof\wURI::getInstance() );
	   }
	   $this->data['tpl_data']['INSTALLER_PHAR_AVAILABLE'] = function(){
 	       return $this->data['INSTALLER_PHAR_AVAILABLE'];
 	    };   
    	
    	
	  }else{
	  	if(is_array($data)){
	  	 foreach($data as $k => $v){
		 	$this->data[$k] = $v;
		 }			
		}

	  }
	 
	
	 if(!isset($path)){
	   $h  = parse_url($this->data['tpl_data']['LOCATION']);
	   $pu = \webdof\wURI::parse_uri($h['scheme'], $h['host'], $h['path']);
	   $path = '/';
	   foreach($pu->dirs as $num => $dir){
	   	 $path.= $dir. '/';
	   }
	 }
	 
	  $this->data['config']['EXTRA'] = $this->_extra($this->data);
		 
	  $this->data['tpl_data']['EXTRA_IS_PMX'] = (true===$this->data['config']['EXTRA']['extra']['pragmamx']['main'])
	                                             ? 'yes' : 'no';	 
		 
	  $this->data['tpl_data']['EXTRA_IS_WP'] = (true===$this->data['config']['EXTRA']['extra']['wordpress']['main'])
	                                             ? 'yes' : 'no';	 


       $this->data['template_main_options'] = array(   
                'Title' =>  'Webfan - Application Composer',
	            'css' => array(
	            
	            ),
			    'js' => array(
				       //->later by assets installer!-> 'js/lib/flow.js',
				       //'http://api.webfan.de/api-d/4/js-api/library.js',
				       (('phar'!==$this->data['tpl_data']['INSTALLER'] && file_Exists($this->data['CONFIGFILE']) && file_exists($this->data['DIR'].'js'. DIRECTORY_SEPARATOR . 'lib'. DIRECTORY_SEPARATOR.'flow.js'))
				        ? 'js/lib/flow.js' : 'http://api.webfan.de/api-d/4/js-api/library.js'),
				       
				       // 'js/app.js', 
				),
				'meta' =>  array(
				     array('http-equiv' => 'content-type', 'content' => 'text/html; charset=utf-8'),	
				     array('http-equiv' => 'content-style-type', 'content' => 'text/css'),	
				     array('http-equiv' => 'content-script-type', 'content' => 'text/javascript'),		
				     array('http-equiv' => 'content-script-type', 'content' => 'text/javascript'),				 
				   /*  array('http-equiv' => 'X-UA-Compatible', 'content' => 'IE=7.5'),		  */
				     array('name' => 'mobile-web-app-capable', 'content' => 'yes'),
				     array('name' => 'apple-mobile-web-app-capable', 'content' => 'yes'),
				     array('name' => 'apple-mobile-web-app-status-bar-style', 'content' => 'lightblue'),
				     array('name' => 'HandheldFriendly', 'content' => 'true'),
				     array('name' => 'MobileOptimized', 'content' => '320'),
				     array('name' => 'viewport', 'content' => 'width=device-width, initial-scale=1.0, user-scalable=yes'),
				     
				     array('name' => 'flow.component.frdl.webfan.api.url', 'content' => $this->data['tpl_data']['URI_DIR_API']),
				     array('name' => 'flow.component.frdl.webfan.api.url.initial', 'content' => $this->data['tpl_data']['URI_DIR_API']),
				     				     
				     array('name' => 'webfan-registration-key', 'content' =>  (isset($this->data['config']['REGISTRATIONKEY']))?$this->data['config']['REGISTRATIONKEY']
				                                                          :(isset($this->data['config_new']['REGISTRATIONKEY']))?$this->data['config_new']['REGISTRATIONKEY']
				                                                          :''),
				 ),
				 
				
				 'link' => array(
				     /* array('rel' => 'prefetch', 'type' => 'application/l10n', 'href' => 'locale/locales.ini'), */
				      array('rel' => 'package', 'type' => 'application/package', 'href' => 'https://github.com/frdl/webfan/archive/master.zip'),
				   //   array('rel' => 'describedby', 'type' => 'application/xml', 'href' => 'config.xml'),
				      array('rel' => 'manifest', 'type' => 'application/manifest+json', 'href' => 'http://'.$_SERVER['SERVER_NAME'].'/'.ltrim(str_replace('setup.php','',$path), '/ ').'manifest.webapp'),
				      
				 )
				 
	    );

	 
		 	       		 	       
	   return $this->data;	 	
	 }
	 
	 
	 
	 protected function _extra(&$data){

            $extractConfig = array();
		 	$extractConfig['extra'] = array();
		 	$extractConfig['extra']['pragmamx'] = array();
		 	$pmxf = $data['DIR'].'mainfile.php';
		 	$extractConfig['extra']['pragmamx']['main'] = (file_exists(DIRECTORY_SEPARATOR . realpath( $pmxf)) && preg_match("/pragmamx/i", file_get_contents(DIRECTORY_SEPARATOR . realpath( $pmxf)))
		 	                                                     ? true
		 	                                                     : false);
		 	$extractConfig['extra']['pragmamx']['installdirs'] = array_merge(glob($pmxf), glob("mainfile.php"), glob("/*mainfile.php"),
		 	                                                               glob("*/*/mainfile.php"),
		 	                                                               glob(getcwd(). DIRECTORY_SEPARATOR . 'mainfile.php') );	
	
		 	$extractConfig['extra']['wordpress'] = array();
		 	$file = 'wp-config.php';
		 	$pmxf = $data['DIR']. $file;
		 	$extractConfig['extra']['wordpress']['main'] = (file_exists(DIRECTORY_SEPARATOR . realpath( $pmxf)) && preg_match("/ABSPATH/", file_get_contents(DIRECTORY_SEPARATOR . realpath( $pmxf)))
		 	                                                     ? true
		 	                                                     : false);
		 	$extractConfig['extra']['wordpress']['installdirs'] = array_merge(glob($pmxf), glob($file), glob("/*".$file),
		 	                                                               glob("*/*/".$file),
		 	                                                               glob(getcwd(). DIRECTORY_SEPARATOR .$file) );	
		 	                    	
		 	                                                               	 	                                                     
    	 	return $extractConfig; 	
	 }
	 
	 
	 protected function _boot(){
	 	$this->default_boot() ;
		
		require  __DIR__ . DIRECTORY_SEPARATOR . self::DIR_PLUGIN . DIRECTORY_SEPARATOR . 'plugout.php';
		require  __DIR__ . DIRECTORY_SEPARATOR . self::DIR_PLUGIN . DIRECTORY_SEPARATOR . 'plugin.php';
		
		
	
		

	 }
	 
	 	
    public function run(&$Request =null){
       	
       if('cli' === PHP_SAPI){
 	  /*    trigger_error('This is a web app, cli support is not implemented yet completly!', E_USER_WARNING);  
 	           //maybe usable if api (cli cmd) request
 	  */
 	      chdir(dirname($_SERVER['argv'][0]));
       }  	
    	
	   	
    	
    	$this->default_run($Request);
    	
    	 $this->out(); 
	   return $this;
	}
	
	
	protected function process_modul($modul){
		
		/*  if('2421fe7de922a9eb14f67e0cd28188594f6b16d2' === sha1($_SERVER['SERVER_NAME']))die('Test: ').$modul;  */
		 switch($modul){
		   	 default : 
		 	  case 'PAGE' :
		 	  case 'HTML' : 
		 	       $this->template = $this->readFile('Main Template');  
		 	    break;
		 	 case 'API' : 
		 	    $this->prepare_api();
		 	    $this->_api();
		 	    break;   
		 	 case '404' : 
		   	      $this->template = $this->prepare404();
		   	   break;
		 }
	}
	
	
    protected function route($u = null){
       $u = (null === $u) ? \webdof\wURI::getInstance() : $u;
     /*  
      $t = ini_get('display_errors'); 
       ini_set('display_errors', 0); 
       trigger_error('@ToDo in '.__METHOD__. ' '.__LINE__. ' : Fix / implement any router', E_USER_NOTICE);
       ini_set('display_errors',$t); 
       */
       
      	
 	  	  	
      if(null===$this->ComponentsManager){
        try{
           $this->ComponentsManager = new \frdl\Flow\Component($this, true, $shop);	 	
	    } 	catch(\Exception $e){
	 	 trigger_error($e->getMessage(), E_USER_ERROR);
	    }		
      }

	   	      
       
       
       $this->__todo($u);
       
       
       try{
	   	 $this->default_route($u);
      
	   }catch(\Exception $e){
	   	 die($e->getMessage());
	   }
       
     if(!is_string($this->modul) || trim($this->modul) === ''){
	 	$this->__todo($u);
	 }else{
	 	$this->process_modul($this->modul);
	 }
       
        
        
       return $this;
	}

 protected function __todo(\webdof\wURI $u = null){
       $u = (null === $u) ? \webdof\wURI::getInstance() : $u;
       $inc_files =  get_included_files();
        array_walk($inc_files, (function(&$file, $num) {
	     	           $file = basename($file);
	     	      }), $this);
         
  
 
    	if(
	         in_array( self::URI_DIR_API , $u->getU()->dirs) 
	     ||  in_array( 'api.php' , $inc_files ) 
	     ||  'api.php' === $u->getU()->file     
	     ||  'frdl.jsonp' === $u->getU()->file     
	     ||  'api' === $u->getU()->file        
	     ||  'jsonp' === $u->getU()->file_ext    
	     ||  'json' === $u->getU()->file_ext    
	     ||  'xml' === $u->getU()->file_ext     
	     ||  'dat' === $u->getU()->file_ext     
	     ||  'bin' === $u->getU()->file_ext     
	     ||  'api' === $u->getU()->file_ext     
	   ){
		 	   /* $this->prepare_api();  */
		 	    $this->_api();
		 	    return $this;
	   }
	   
	 ob_start(function($content){
	   $parseHeaders =function($serverVars = NULL)
      {

	
      if( !is_array($serverVars))$serverVars = $_SERVER;

       $headers = array();
       foreach($_SERVER as $key=>$value)
         {
                if (substr($key,0,5)=="HTTP_") {
                     $key=str_replace(" ","-",ucwords(strtolower(str_replace("_"," ",substr($key,5)))));
                     $headers[$key]=$value;
                     if( $key == 'If-None-Match' )
                      {
                        $ifNoneMatch = $headers['If-None-Match'];
                        if(substr($ifNoneMatch, 0, 1) != '"')$ifNoneMatch = NULL;
                      }
                     if( $key == 'If-Modified-Since' )
                      {
                        $ifModifiedSince = $headers['If-Modified-Since'];
                      }
                }
      }
       return $headers;
      };

       $headers=$parseHeaders($_SERVER);
       if(isset($headers['X-Requested-With']) && 'XMLHttpRequest'===$headers['X-Requested-With']){
	
		preg_match("/<body>(.*)<\/body>/s", $content, $matches);
			//for cache GET:
			$_GET['_______X-Requested-With']='XMLHttpRequest';
			if(isset($matches[1]))$content=((isset($documentTitle)) ? '<meta name="document.title" content="'.strip_tags($documentTitle).'" />' : '').$matches[1];
	
       }	
       return $content; 	
	});  


	   
	   if(
	          'html' === $u->getU()->file_ext      
	       || '/' === $u->getU()->req_uri 
	       || basename(__FILE__) ===  $u->getU()->file
	       || 'install.phar' === $u->getU()->file
	       || 'install.php' === $u->getU()->file
	       || substr($u->getU()->location,0,strlen($this->data['config']['URL']))  === $this->data['config']['URL']
	   ){
	   
	   	   
 	      $this->data['tpl_data']['TPL_FRDL_WEBFAN_INSTALL_HTML'] = function(){
 	      	 $html='';
 	      	 $u=\webdof\wURI::getInstance();
 	      	 
 	      	 $options = array(
                       'preferLocal'=>('install.phar' === $u->getU()->file || 'install.php' === $u->getU()->file) ? false : true,
                       'forceLibraryJSInvocation' => false,
                       'URL_DEFAULT' => 'widget://example.com/',
                       'components_dir' => null,
                       'components_url' => null,
       
             );
 	      	 
 	      	 $html.= $this->ComponentsManager->html('frdl/webfan', 'Widget', $options);
    	 
 	      	 
/* 	 Getting
<div data-frdl-desktop-widget="widget://example.com/frdl/webfan"></div>
<div data-frdl-desktop-widget="widget://example.com/webfan/marketplace"></div>
*/
             $html.= $this->ComponentsManager->html('frdl/webfan', 'DesktopWidget', $options); 
 	      	 $html.= $this->ComponentsManager->html('webfan/marketplace', 'DesktopWidget', $options);  	      	 
	 
 
 
$html.=<<<HTML


<img src="http://images.webfan.de/ajax-loader_2.gif"  class="img-ajax-loader" style="float:center;top:50%;left:50%;position:fixed;" />
<script type="text/javascript">
(function($){
\$(document).ready(function() {
  frdl.addReadyCheck(function(){
  	     return (0<frdl.UI.widgets.length) ? true : false;
  }); 
  		
frdl.ready(function() {
	setTimeout(function(){
      frdl.each(frdl.\$q('img[src$="ajax-loader_2.gif"]'), function(i,el){
  	     el.style.display='none';
      });		
	},5000);
});
});	
})(jQuery);	
</script>	



HTML;



 



 
 	      	 
 	         return $html;
 	      };	 
 	        	   
	       $this->template = $this->readFile('Main Template'); 
	       
 	   }/* elseif (file_exists($u->getU()->path) && is_file($u->getU()->path)){
	   	    $this->template = $this->readFile('Main Template');  
	   }*/
	    else{
	   	   $this->template = $this->prepare404();
	   }	
        
              
	   return $this;
	}			
	


	
	
	protected function _installFromPhar($u){
	   global $include;	
	   $this->data['INSTALLER_PHAR_AVAILABLE'] = '1';
	   $f = ( false !== strpos(\webdof\wURI::getInstance()->getU()->location, 'install.phar') ) ? 'install.phar' : 'install.php';
	   
	   /*
       $f2 = ( false !== file_exists($this->data['DIR'] . 'install.phar') ) ? 'install.phar/'
                   : ( false !== file_exists($this->data['DIR'] . 'install.php') ) ? 'install.php/' : '';	   
	   */
       $f2 = (  file_exists($this->data['DIR'] . 'install.phar') || 'install.phar' === basename(__FILE__) ) ? 'install.phar/'
                   : ( file_exists( $this->data['DIR'] .'install.php') ) ? 'install.php/' : '';	   	   
	   
	   $this->data['tpl_data']['URI_DIR_API'] =  $this->data['tpl_data']['URL'].$f.'/api.php';	
	   $this->data['tpl_data']['EXTRA_PMX_URL'] =  $this->data['tpl_data']['URL'].$f.'/pragmamx.php';	
	   $this->data['tpl_data']['INSTALLER'] = 'phar';
       $this->data['PHAR_INCLUDE'] = str_replace('phar://', '',$include);  	
       

       $this->data['tpl_data']['EXTRA_PHAR_URL'] = $this->data['tpl_data']['URL'].$f2.'api.php';	
       
       
       
       if('' !== $include) $this->data['INSTALLER'] = 1;
       

    	

	   return $this;
	}


    public function OutData(){
    	$p = func_get_args();
    	if(0 === count($p)){
			return $this->data['data_out'];
		}elseif(1 === count($p)){
			$this->data['data_out'] = $p[0];
		}elseif(2 === count($p) && is_string($p[0])){
			$this->data['data_out']->{$p[0]} = $p[1];
		}else{
			return trigger_error('Invalid number of arguments in '.__METHOD__.' '.__LINE__, E_USER_ERROR);
		}
		
		return $this;
	}
	
	
	
	public function login(){
    	 	if( 
    	 	
    	 	 isset($_POST['pwd']) && isset($_POST['PIN'])
    	 	&& ((
 		 	 $this->data['config']['ADMIN_PWD'] === sha1(trim($_POST['pwd'], '"\' '))
		 	&& $this->data['config']['HOST'] === $_SERVER['SERVER_NAME']
		 	&& $this->data['config']['PIN'] ===$_POST['PIN']
		 	&& (!isset($this->data['config']['DISABLE_ADMIN_PWD']) || false === $this->data['config']['DISABLE_ADMIN_PWD'])
		    	)
		 	  || (
 		 	          $this->data['config_new']['ADMIN_PWD'] === sha1(trim($_POST['pwd'], '"\' '))
		 	       && $this->data['config_new']['HOST'] === $_SERVER['SERVER_NAME']
		 	       && $this->data['config_new']['PIN'] ===$_POST['PIN']
		 	       && (!isset($this->data['config_new']['DISABLE_ADMIN_PWD']) || false === $this->data['config_new']['DISABLE_ADMIN_PWD'])
		 	))
		 	
		 	){
 		 	    $this->aSess['ADMIN_PWD'] =  sha1(trim($_POST['pwd'], '"\' '));
		 	    $this->aSess['HOST'] = $_SERVER['SERVER_NAME'];
		 	    $this->aSess['PIN'] =$_POST['PIN'];
		 	    $this->aSess['isAdmin'] = true;
			 	session_write_close();
			 	session_start();    
			 	
			 	

	 	
			 	
			} elseif(isset($_POST['pwd']) || isset($_POST['PIN'])){
				if(isset( $this->aSess['isAdmin']))unset( $this->aSess['isAdmin']);
				if(!isset($_REQUEST['test'])){
         	    	foreach($this->aSess as $k => $v){
					   unset($this->aSess[$k]);
				   }					
				}

			}  	 
				
		
		return $this->isLoggedIn();		
	}
	
	public function isLoggedIn(){
       $this->isAdmin = false;


/*
		foreach($this->data['config']['EXTRA']['extra']['pragmamx']['installdirs'] as $mainfile){
			try{
				
			  $func = function($file){
			  	  ob_start();
			  		@include $file;
			      ob_end_clean();		
			  };
			
			 $func($mainfile);
			
			 if(MX_IS_ADMIN){
			 	  $this->aSess['isAdmin'] = true;
			 }
			 
			
			  
			}catch(\Exception $e){
				
			}
		}
*/		
      if(true===$this->data['config']['EXTRA']['extra']['pragmamx']['main'] 
       && file_exists( $this->data['DIR'] . 'config.php')){
			try{
			  $file = $this->data['DIR'] . 'mainfile.php';
			  	
			  $func = function($file){
			  	  ob_start();
			  		@include $file;
			      ob_end_clean();		
			  };
			
			 $func($mainfile);
			
			 if(MX_IS_ADMIN){
			 	  $this->aSess['isAdmin'] = true;
			 }
			 
			
			  
			}catch(\Exception $e){
				
			}	  	
	  }


	
		
		 	if(true !== $this->aSess['isAdmin']){
		 		$this->isAdmin = false;
		 		unset($this->aSess['ADMINDATA']);
		 		$this->aSess['ADMINDATA'] = array(
		 		   'CONFIGFILE' => $this->data['CONFIGFILE'],
		 		);
		 		if(isset( $this->aSess['isAdmin']))unset( $this->aSess['isAdmin']);
			}else{
				   $this->aSess['ADMINDATA'] = $this->data;
				   $this->isAdmin = true;
			}	 		
			
					
		$this->aSess['isAdmin']	= $this->isAdmin;	
		return $this->isAdmin;	
	}
	
    protected function _api($u = null){
		 $u = (null === $u) ? \webdof\wURI::getInstance() : $u;
		ini_set('display_errors', 0);
		 
        $this->login();	 
	  	
		 	 			 
			/*
			* ToDo:  set output formatter (defaults to jsonp)
			*/	
	  	    $this->ob_compress();
			header("Content-Type: application/x-javascript; charset=UTF-8;");
		 	ob_start(function($c){
		 		       	 $r = (isset($this->data['data_out'])) ? $this->data['data_out'] :  new \stdclass;
		 		       	 $r->type = (isset($r->type)) ? $r->type : 'print';
		 		       	 $r->out = (isset($r->out)) ? $r->out : $c;
      	                 $fnregex = "/^[A-Za-z0-9\$\.-_\({1}\){1}]+$/";
      	                 $callback = (isset($_REQUEST['callback']) && preg_match($fnregex, $_REQUEST['callback']))
		                   ? strip_tags($_REQUEST['callback'])
		                   : '';
		                   
		                   
                if($callback === ''){
         	            $o = json_encode($r);
                }  else {
                	       $r->callback = $callback;
                           $o = $callback.'(' . json_encode($r) . ')';
		                }
		        
		  
		        return $o;
		 	});
		 		
		 
		
		
	
		 
		 
		 /* BEGIN extract phar (todo build/refactor API) */
		 if(isset($_GET['EXTRA_EXTRACT_PHAR']) ){
		

		 	
		 	if(file_exists( $this->data['CONFIGFILE']) && $this->data['config_new']['PACKAGE'] !== $this->data['config']['PACKAGE'] ){
		 		\webdof\wResponse::status(409);
			    $str ='Error: Invalid installer package name';
				if(true === $this->debug)trigger_error($str, E_USER_ERROR);
				die($str);				
			}
		 	
		 	if( 1 !== intval($this->data['INSTALLER_PHAR_AVAILABLE'])
		 	  || intval( str_replace(array('"', "'"), array('',''), $this->data['INSTALLER']) ) !== 1
		 	  || !isset( $this->data['PHAR_INCLUDE'])
		 	  || !class_exists('\Extract')
		 	){
		 		\webdof\wResponse::status(400);
			    $str ='Error: Not in installer context';
				if(true === $this->debug)trigger_error($str, E_USER_ERROR);
				die($str);			
			}

		 	
		 	if(true !== $this->isLoggedIn()){
		 		\webdof\wResponse::status(401);
				die('Invalid credentials, try to install via <a href="{___$$URL_INSTALLER_HTMLPAGE$$___}">{___$$URL_INSTALLER_HTMLPAGE$$___}</a>!');
			}
		 	
		 	
		 	
		 	
		 	
		 	
		 	
		 	    try{
	                     $userInfo=posix_getpwuid(fileowner(__FILE__)); 		
			 			$this->data['config']['DIR_PACKAGE'] = $userInfo['dir'].DIRECTORY_SEPARATOR.'files'.DIRECTORY_SEPARATOR;
			 			chmod($this->data['config']['DIR_PACKAGE'],0755);
			 			if(!is_dir($this->data['config']['DIR_PACKAGE']) || !is_writable($this->data['config']['DIR_PACKAGE'])){
							$this->data['config']['DIR_PACKAGE'] =$userInfo['dir'].DIRECTORY_SEPARATOR;
							chmod($this->data['config']['DIR_PACKAGE'],0755);
						}
			 		
			 		   if(!is_dir($this->data['config']['DIR_PACKAGE']) || !is_writable($this->data['config']['DIR_PACKAGE'])){	
			 			$this->data['config']['DIR_PACKAGE'] = $this->data['DIR'];
			 		  }		 	
		 					
				}catch(\Exception $e){
			       $str ='Warning: Cannot get home dir';
				   if(true === $this->debug)trigger_error($str, E_USER_WARNING);
				   $this->data['config']['DIR_PACKAGE'] = $this->data['DIR'];			
				}
            if(isset($_REQUEST['DIR_PACKAGE']) && is_dir($_REQUEST['DIR_PACKAGE']) ){
				 chmod($_REQUEST['DIR_PACKAGE'],0755);
				 $this->data['config']['DIR_PACKAGE'] = $_REQUEST['DIR_PACKAGE'];		
			}
		 	
			if(!is_dir($this->data['config']['DIR_PACKAGE']) || !is_writable($this->data['config']['DIR_PACKAGE'])){	
			   $this->data['config']['DIR_PACKAGE'] = $this->data['DIR'];
			}		
			 		  		
			 		  		
			 		  		
	        if(isset($_REQUEST['DIR_WWW']) && is_dir($_REQUEST['DIR_WWW']) ){
				 chmod($_REQUEST['DIR_WWW'],0755);
				 $this->data['config']['DIRS']['www'] = $_REQUEST['DIR_WWW'];		
			}         		 		  		
			if(!is_dir($this->data['config']['DIRS']['www']) || !is_writable($this->data['config']['DIRS']['www'])){	
			   $this->data['config']['DIRS']['www'] = $this->data['DIR'].'www'.DIRECTORY_SEPARATOR;
			}		
			 					 		  		
			 		  		
			 		  		
		   $this->data['CONFIGFILE'] = $this->data['config']['DIR_PACKAGE'].'config.frdl.php';
			 		 
			 		  		 	
		   if(isset($_REQUEST['test']) && 'response' === $_REQUEST['test']){
		   	    \webdof\wResponse::status(200);
		   	    $this->data['data_out']->code = 200;
		   	    $this->data['data_out']->extra = true;
		   	    $this->data['data_out']->out = 'OK';		   	    
		   	    $this->data['data_out']->changed = (json_encode($this->data['config']) !== json_encode($this->data['config_new']));
		   	 

                $this->data['data_out']->config =  new \stdclass;
                $this->data['data_out']->config_new = new \stdclass;                
		
                $this->data['data_out']->config->PACKAGE =  $this->data['config']['PACKAGE'];
                $this->data['data_out']->config_new->PACKAGE =  $this->data['config_new']['PACKAGE'];
                
		
                $this->data['data_out']->config->VERSION =  $this->data['config']['VERSION'];
                $this->data['data_out']->config_new->VERSION =  $this->data['config_new']['VERSION'];
                
              		
                $this->data['data_out']->config->INSTALLED =  $this->data['config']['INSTALLED'];
                $this->data['data_out']->config_new->INSTALLED =  $this->data['config_new']['INSTALLED'];
                
              		
                $this->data['data_out']->config->REGISTERED =  $this->data['config']['REGISTERED'];
                $this->data['data_out']->config_new->REGISTERED =  $this->data['config_new']['REGISTERED'];
                
              		
                $this->data['data_out']->config->UNAME =  $this->data['config']['UNAME'];
                $this->data['data_out']->config_new->UNAME =  $this->data['config_new']['UNAME'];
                
              		
                $this->data['data_out']->config->UID =  $this->data['config']['UID'];
                $this->data['data_out']->config_new->UID =  $this->data['config_new']['UID'];
                
                
              		
                $this->data['data_out']->config->DIR_PACKAGE =  $this->data['config']['DIR_PACKAGE'];
                $this->data['data_out']->config_new->DIR_PACKAGE =  $this->data['config_new']['DIR_PACKAGE']; 
                
                
                $wwwdir =(is_dir($this->data['config']['DIRS']['www'])) ? $this->data['config']['DIRS']['www'] : $_SERVER['DOCUMENT_ROOT'] . DIRECTORY_SEPARATOR;
                $this->data['data_out']->config->DIR_WWW =  $wwwdir;
                $this->data['data_out']->config_new->DIR_WWW =  $wwwdir;   
                
                
                                           		   	    	   	       	       
		   	    die('OK');
		   }
		 	
		 	$EXTRA = &$this->data['config']['EXTRA'];
		 	
		 	mkdir($this->data['config']['DIR_PACKAGE'],0755,true);
		 			 	
		 	try{
				\Extract::from($this->data['PHAR_INCLUDE'])->to( /* $this->data['DIR'] */ $this->data['config']['DIR_PACKAGE'] ,
                   function (\Entry $entry) use(&$EXTRA) {
                      if (false == strpos(basename($entry->getName()), '.')
                        && (
                                 true == \webdof\valFormats::is(basename($entry->getName()), 'md5', true)
                              || true == \webdof\valFormats::is(basename($entry->getName()), 'sha1', true)    
                            )     
                      ) {
                            return; 
                      }                    
                      
                      if('config.frdl.php' == basename($entry->getName()) || 'config.php' == basename($entry->getName())){
					  	 return;
					  }
					  
					//  if(true == $EXTRA['extra']['pragmamx']['main'] ){
					  	 if('.htaccess' === basename($entry->getName())) return;
					  	 if('index.php' === basename($entry->getName())) return;
					//   }
					  
                   });
                   

                   
			}catch(\Exception $e){
				//\webdof\wResponse::status(409);
				//$str = $this->data['PHAR_INCLUDE'] .' -> '.$this->data['DIR'].' ('.__LINE__.') - ' .$e->getMessage();
				//if(true === $this->debug)trigger_error($str, E_USER_ERROR);
				//die($str);
			}
		 	 
		 	 if(file_exists($this->data['config']['DIR_PACKAGE']. 'composer.json')){
		 	 	
	
		 	 	
			 			/*
			 	   		 $.WebfanDesktop.Registry.Programs[\'frdl-webfan\'].config.loc.api_url="'.$this->data['config']['URL_API_ORIGINAL'].'";
			 			*/
			 			$this->data['data_out']->js = trim(preg_replace("/\s+|\n/", " ", 'try{
			 			$(\'#window_\' + \'frdl-webfan\').find(\'#wd-li-frdl-webfan-installPHAR\').find(\'u\').html(\'Update\');
			 			$.WebfanDesktop.Registry.Programs[\'frdl-webfan\'].formConfig();
			 		
			 			}catch(err){console.error(err);}			 			
			 			'));
			 			
			 			
			 			if(''===$this->data['config_new']['ADMIN_PWD']){
							$this->data['config_new']['ADMIN_PWD']= $this->data['config']['ADMIN_PWD'];
						}
			 			
			 			
			 			if($this->data['config_new']['ADMIN_PWD'] !== $this->data['config']['ADMIN_PWD']){
							$this->data['data_out']->js.= ' 
					     		alert("Attention: Password has changed ('.trim($_POST['pwd'], '"\' ').')!");
							 ';
						}
			 			
			 			if(''===$this->data['config_new']['PIN']){
							$this->data['config_new']['PIN']= $this->data['config']['PIN'];
						}			 			
			 			if($this->data['config_new']['PIN'] !== $this->data['config']['PIN']){
							$this->data['data_out']->js.= ' 
					     		alert("Attention: PIN has changed ('.$this->aSess['PIN'].')!");
							 ';
						}
									 		
									 		
			 			$this->data['config']['VERSION'] = $this->data['config_new']['VERSION'];
			 			$this->data['config']['DOWNLOADUPDATETIME'] = $this->data['config_new']['DOWNLOADTIME'];
			 			
			 			
			 			$this->data['config']['UPDATETIME'] = time();
			 			
			 			$this->data['config']['ADMIN_PWD'] = $this->aSess['ADMIN_PWD'];
			 			$this->data['config']['PIN'] = $this->aSess['PIN'];
			 			
			 			
	
			 		 	
			 			if(0 === intval($this->data['config']['UID']) && 0 !== intval($this->data['config_new']['UID']) ){
							$this->data['config']['UID'] = $this->data['config_new']['UID'];
						}
			 			
				 			
			 			if( '' === $this->data['config']['UNAME'] && '' !== $this->data['config_new']['UNAME']){
							$this->data['config']['UNAME'] = $this->data['config_new']['UNAME'];
						}
	 			
	 			
			 			$this->data['config']['DIRS'] = array_merge((isset($this->data['config']['DIRS']) && is_array($this->data['config']['DIRS']))
			 			         ? $this->data['config']['DIRS'] : array(), array(
			 			            'apps' =>  $this->data['config']['DIR_PACKAGE'] . '.ApplicationComposer'. DIRECTORY_SEPARATOR .'apps'. DIRECTORY_SEPARATOR,
			 			            'components' =>  $this->data['config']['DIR_PACKAGE'] . '.ApplicationComposer'. DIRECTORY_SEPARATOR .'components'. DIRECTORY_SEPARATOR,			 			            
			 			            'batch' =>  $this->data['config']['DIR_PACKAGE'] . '.ApplicationComposer'. DIRECTORY_SEPARATOR .'batch'. DIRECTORY_SEPARATOR,
			 			            'cache' =>   $this->data['config']['DIR_PACKAGE'] . '.ApplicationComposer'. DIRECTORY_SEPARATOR .'cache'. DIRECTORY_SEPARATOR,
			 			            'config' =>   $this->data['config']['DIR_PACKAGE'] . '.ApplicationComposer'. DIRECTORY_SEPARATOR .'config'. DIRECTORY_SEPARATOR,
			 			            'data.norm' =>   $this->data['config']['DIR_PACKAGE'] . '.ApplicationComposer'. DIRECTORY_SEPARATOR .'data.norm'. DIRECTORY_SEPARATOR,
			 			            'data.storage' =>   $this->data['config']['DIR_PACKAGE'] . '.ApplicationComposer'. DIRECTORY_SEPARATOR .'data.storage'. DIRECTORY_SEPARATOR,
			 			            'packages' =>   $this->data['config']['DIR_PACKAGE'] . '.ApplicationComposer'. DIRECTORY_SEPARATOR .'packages'. DIRECTORY_SEPARATOR,
			 			            'repositories' =>   $this->data['config']['DIR_PACKAGE'] . '.ApplicationComposer'. DIRECTORY_SEPARATOR .'repositories'. DIRECTORY_SEPARATOR,
			 			            'servers' =>   $this->data['config']['DIR_PACKAGE'] . '.ApplicationComposer'. DIRECTORY_SEPARATOR .'servers'. DIRECTORY_SEPARATOR,
			 			            'share' =>   $this->data['config']['DIR_PACKAGE'] . '.ApplicationComposer'. DIRECTORY_SEPARATOR .'share'. DIRECTORY_SEPARATOR,
			 			            'tmp' =>   $this->data['config']['DIR_PACKAGE'] . '.ApplicationComposer'. DIRECTORY_SEPARATOR .'tmp'. DIRECTORY_SEPARATOR,
			 			            'vendor' =>   $this->data['config']['DIR_PACKAGE'] . '.ApplicationComposer'. DIRECTORY_SEPARATOR .'vendor'. DIRECTORY_SEPARATOR,
                                    'www' =>   (is_dir($this->data['config']['DIRS']['www']) && is_writable($this->data['config']['DIRS']['www'])) ? $this->data['config']['DIRS']['www'] : $_SERVER['DOCUMENT_ROOT'] . DIRECTORY_SEPARATOR ,
			 					    'files' =>	(isset($_REQUEST['EXTRA_DIR']) && is_dir($_REQUEST['EXTRA_DIR']) )	? $_REQUEST['EXTRA_DIR'] : getcwd(),
			 					    	                 
			 			  ));
			 					
			 					
			 			
			 			$files = array();
			 			
			 			$this->data['config']['FILES'] = array_merge((isset($this->data['config']['FILES']) && is_array($this->data['config']['FILES']))
			 			         ? $this->data['config']['FILES'] : array(), array(
			 			            'composer' =>  $this->data['config']['DIR_PACKAGE'] . 'composer.json',
			 			            'config' =>    $this->data['CONFIGFILE'],
			 			            'database-schema' =>  $this->data['config']['DIRS']['config'] . 'database-schema.dat', 
			 			            'boot.batch' =>  $this->data['config']['DIRS']['batch'] . '.boot.bat',     
			 			  ));					 					
			 				
			 			
			 			$config = $this->data['config'];	
			 			if(true === $EXTRA['extra']['pragmamx']['main'] ){
                        	$config['URL'] .= 'setup.php';
                        }
                        	
			 				
			 					 			
			 			$php = "<?php
			 			/*
			 			  - Do not edit this file manually! 
			 			  Application Composer - Config
			 			  Download: {___$$URL_INSTALLER_HTMLPAGE$$___}
			 			  
			 			*/
			 			    if(isset(\$this) &&
			 			     (  get_class(\$this) === '\\".get_class($this)."' 
			 			     || is_subclass_of(\$this, '\\frdl\ApplicationComposer\Command\CMD')  
			 			     || get_class(\$this) === '".get_class($this)."' 
			 			     || is_subclass_of(\$this, 'frdl\ApplicationComposer\Command\CMD')  
			 			     )
			 			     ){
			 			     	 \$this->data['config'] = ".var_export($config, true).";		
			 			     	
                         	    ";





$php .= "


/*
* If you have PragmaMx installed, its db-config will be used instead!
*/
\$pmxconfigfile=__DIR__.DIRECTORY_SEPARATOR. 'config.php';
if(true === \$this->data['config']['EXTRA']['extra']['pragmamx']['main'] && file_exists( \$pmxconfigfile)  ){
	try{
	  ob_start();
		@include \$pmxconfigfile;
		if(isset(\$dbtype))\$this->data['config']['db-driver']=strtolower(\$dbtype);
		if(isset(\$dbhost))\$this->data['config']['db-host']=\$dbhost;
		if(isset(\$dbuname))\$this->data['config']['db-user']=\$dbuname;
		if(isset(\$dbpass))\$this->data['config']['db-pwd']=\$dbpass;
		if(isset(\$dbname))\$this->data['config']['db-dbname']=\$dbname;
		if(isset(\$prefix))\$this->data['config']['db-pfx']=\$prefix;
	  ob_end_clean();			
	}catch(\\Exception \$e){
		
	}

}



";      

                     	    
                         	    						
						
						$php .= "}";
			 			
			 			file_put_contents($this->data['CONFIGFILE'], $php);
							 			
						
						/*
						if(dirname(realpath($this->data['DIR']))!==dirname(realpath($this->data['config']['DIR_PACKAGE']))){
							$this->copy_dir($this->data['DIR'], $this->data['config']['DIR_PACKAGE'], true);
							rmdir($this->data['DIR'].'.ApplicationComposer'.DIRECTORY_SEPARATOR);
							
						}
						*/
							
						$msg='';
						
			$EXTRA_DIR = (''!==$_REQUEST['DIR_WWW'] && is_dir($_REQUEST['DIR_WWW'])) ? rtrim($_REQUEST['DIR_WWW'], '/ ') : $this->data['config']['DIRS']['www'];			
			mkdir($EXTRA_DIR, 0755, true);
			
						
			if('yes'===$_REQUEST['INSTALL_UPDATE_PMX']){
				$tok = 'http://download.pragmamx.org/pmx/';
				if($tok===substr($_REQUEST['INSTALL_UPDATE_PMX_URL'],0,strlen($tok))){
				  $zipcontents = file_get_contents($_REQUEST['INSTALL_UPDATE_PMX_URL']);
				  if(false===$zipcontents){
				  	$msg.='Download of PragmaMx failed!';
				  }else{
				  	$zipfilename =sys_get_temp_dir().DIRECTORY_SEPARATOR . '~tmp.pragmamxdownload.zip';
				  	file_put_contents( $zipfilename, $zipcontents);
				  	$Zip = new \frdl\webfan\Compress\zip\wUnzip($zipfilename, $EXTRA_DIR);
				  	$r = $Zip->unzip();
				  	$msg.='PragmaMx extracted.';
					unlink($zipfilename);
					
					
					$zipcontents = file_get_contents('https://github.com/frdlweb/flow4pmx/archive/master.zip');
				  if(false===$zipcontents){
				  	$msg.='Download of flow4pmx failed!';
				  }else{
				  	$zipfilename =sys_get_temp_dir().DIRECTORY_SEPARATOR. '~tmp.flow4pmx.zip';
				  	file_put_contents( $zipfilename, $zipcontents);
				  	$Zip = new \frdl\webfan\Compress\zip\wUnzip($zipfilename, $EXTRA_DIR);
				  	$r = $Zip->unzip();
				  	$this->copy_dir($EXTRA_DIR.'flow4pmx-master'.DIRECTORY_SEPARATOR, DIRECTORY_SEPARATOR.ltrim($EXTRA_DIR,'/ '), true);
				  	rmdir($EXTRA_DIR.'flow4pmx-master'.DIRECTORY_SEPARATOR);
				  	$msg.='flow4pmx extracted.';
					unlink($zipfilename);
				  }
					
				  }
				}
				
			  	
			}	
			/* eo install/update pmx */		
			
			
						
			if('yes'===$_REQUEST['INSTALL_UPDATE_WP']){
				$tok = 'https://wordpress.org/';
				if($tok===substr($_REQUEST['INSTALL_UPDATE_WP_URL'],0,strlen($tok))){
				  $zipcontents = file_get_contents($_REQUEST['INSTALL_UPDATE_WP_URL']);
				  if(false===$zipcontents){
				  	$msg.='Download of Wordpress failed!';
				  }else{
				  	$zipfilename =sys_get_temp_dir().DIRECTORY_SEPARATOR . '~tmp.wordpressdownload.zip';
				  	file_put_contents( $zipfilename, $zipcontents);
				  	$Zip = new \frdl\webfan\Compress\zip\wUnzip($zipfilename, $this->data['DIR']);
				  	$r = $Zip->unzip();
				  	/* rename(ltrim($this->data['DIR'], '/ ').'wordpress',trim($this->data['DIR'], '/ ')); */
				  	$this->copy_dir($EXTRA_DIR.'wordpress'.DIRECTORY_SEPARATOR, DIRECTORY_SEPARATOR.ltrim($EXTRA_DIR,'/ '), true);
				  	rmdir($this->data['DIR'].'wordpress'.DIRECTORY_SEPARATOR);
				  	$msg.='Wordpress extracted.';
					unlink($zipfilename);
				  }
				}
				

			}				
			
					
			try{
				file_put_contents($this->data['DIR'] .'js'.DIRECTORY_SEPARATOR.'lib'.DIRECTORY_SEPARATOR.'flow.js' ,file_get_contents('http://api.webfan.de/api-d/4/js-api/library.js'));
			
			}catch(\Exception $e){
				//	\webdof\wResponse::status(409);
			//		$str = $this->data['PHAR_INCLUDE'] .' -> '.$this->data['DIR'].' - ('.__LINE__.') ' .$e->getMessage();
			//		if(true === $this->debug)trigger_error($str, E_USER_ERROR);
			//	die($str);	 		
			}				 			
			
						  
				  
		    	unset($Zip,$r,$tok,$zipcontents,$zipfilename );
	

$DIR_PACKAGE = rtrim(realpath($this->data['config']['DIR_PACKAGE']), '/ ').DIRECTORY_SEPARATOR;
$VERSION=$this->data['config']['VERSION'];
$SERVERCODE=<<<PHP
<?php
/**
*  Generated by frdl/webfan
*  This file should NOT be edited manually!
*  
*  @role:      server
*  @app:       frdl/webfan
*  @version:   $VERSION
*  @project:   @root  
*  @dir:       $DIR_PACKAGE
*
*/
namespace frdlweb\\webfan\\server;
\$dir = '$DIR_PACKAGE';
chdir(\$dir);
require \$dir.'.ApplicationComposer'. DIRECTORY_SEPARATOR .  'bootstrap.php';
require \$dir.'.ApplicationComposer'. DIRECTORY_SEPARATOR .  'apps' . DIRECTORY_SEPARATOR . 'webfan.fexe.php';


PHP;


foreach(array(
 DIRECTORY_SEPARATOR.ltrim($this->data['DIR'],'/ ').'~index.php',
 DIRECTORY_SEPARATOR.ltrim($this->data['DIR'],'/ ').'api.php',
 DIRECTORY_SEPARATOR.ltrim($this->data['DIR'],'/ ').'app.php',
 DIRECTORY_SEPARATOR.ltrim($this->data['DIR'],'/ ').'setup.php',

) as $serverFile){
	file_put_contents( $serverFile, $SERVERCODE);
}
	
	
			
			  if(!file_exists( DIRECTORY_SEPARATOR.ltrim($this->data['DIR'],'/ '). 'index.php')){
			     copy('~index.php',DIRECTORY_SEPARATOR.ltrim($this->data['DIR'],'/ '). 'index.php' );
			  }
			
			
							 			
			 		    if(isset($_REQUEST['u'])){
			 		    	unlink( $this->data['PHAR_INCLUDE']);
			 		    	$this->data['data_out']->js.= ' $.WebfanDesktop.Registry.Programs[\'frdl-webfan\'].config.EXTRA_INSTALLER = null;	';
			 		    }
			 			
			 				 			
	                     $config['URL'] = str_replace('setup.phpsetup.php', 'setup.php', $config['URL']);

					 	   	$this->data['data_out']->js.= '
			                	$(\'#window_main_postbox-ttt-all\').wdPostbox(\'deleteMessage\', \'install-frdl-webfan-installer-'.$this->data['config_new']['VERSION'].'\',  \'update\', false);	 	   	
					 	   	
					 	   	
					 	   	alert(\''.$msg.'\nPlease set up the configuration next...\');
			 		    	window.location = "'.$config['URL'].'";
			 		    	';															 		
		             
		             
		             $this->writeToConfigFile();
		             
		              \webdof\wResponse::status(201);
		 	            die('Extracted');
			 }else{
				$str = 'Error extracting php archive ('.__LINE__.') ';
				\webdof\wResponse::status(409);
				if(true === $this->debug)trigger_error($str, E_USER_ERROR);
				die($str);			 	
			 }
		 
		 }
		 /* END extract (todo) */
		 elseif(isset($_REQUEST[self::CMD])){
		 	return $this->_api_request_cmd($_REQUEST[self::CMD]);
		 }
		 
		 
		 \webdof\wResponse::status(404);
		 die('Unexpected end of api.request');
	}
     
	
	
	
	
	
	public function copy_dir($src,$dst, $delete  = true, $chmod = 0755) {
      $dir = opendir($src);
      @mkdir($dir, 755, true);
      while(false !== ( $file = readdir($dir)) ) {
        if (( $file != '.' ) && ( $file != '..' )) {
            if ( is_dir($src . '/' . $file) ) {
               
            }
            else {
                copy($src . '/' . $file,$dst . '/' . $file);
                chmod($dst . '/' . $file, $chmod);
                if(true===$delete)unlink($src . '/' . $file);
            }
        }
      }
      closedir($dir);
      
     $dir = opendir($src); 
       while(false !== ( $file = readdir($dir)) ) {
        if (( $file != '.' ) && ( $file != '..' )) {
            if ( is_dir($src . '/' . $file) ) {
                $this->copy_dir($src . '/' . $file,$dst . '/' . $file, $delete);
                if(true===$delete)rmdir($src . '/' . $file);
                chmod($dst . '/' . $file, $chmod);
            }
            else {
               
            }
        }
      }
           
      closedir($dir);
      if(true===$delete)rmdir($dir);
   } 	
	
	
	
	
	
	public function prepare404(){
		\webdof\wResponse::status(404);
		$this->template = $this->readFile('404');
		return $this->template.$this->route;
	}
	
	/**
	* 
	* @param String $cmd
	* @param Array $processors default null (defaults to self settings)
	* 
	* @return mixed $result || array of [mixed result] || false || null
	* 
	*    return value is an array of corresponsing results if count($processors) > 1
	* 
	*/
	public function cmd($cmd, $processors = null/* run the comand on multiple clis, just like hooks or similar 
	
	example (default) 
	array(
	         'frdl' => array(
	             'cli.cmd.cli' => 'frdl', //) inital/shell command, you may trim it and shift it from command line 
	             'cli.class' => '\frdl\ApplicationComposer\Console', //a cli/processor class as command handler
	                                                 // MUST provide public method applyApp($this)
	                                                 // MUST provide public method exe($cmd)
	                                                 // MUST provide public method dump()  ( resultGetter )
	                                                 // MUST be subclass_of 'cli.class.required.parent' ...
	             'cli.class.required.parent' => '\frdl\aSQL\Engines\Terminal\CLI',
	         ),
	   );
	*/, &$errorlog=array(), $eLevel=/*null=>disables trigger error*/E_USER_WARNING){
		
    if(!is_array($processors))$processors=&$this->data['settings']->cli;
    $result=(1 < count($processors)) ? array() : null;
    $mulitMode = (null===$result) ? false : true;
    $i=0;
    
	try{
	if(null === self::$_db){
		self::$_db =\frdl\DB::_(array(
		//self::$_db =  new \frdl\DB(array(
		   'driver' => $this->data['config']['db-driver'],
		   'host' => $this->data['config']['db-host'],
		   'dbname' => $this->data['config']['db-dbname'],
		   'user' => $this->data['config']['db-user'],
		   'password' => $this->data['config']['db-pwd'],
		   'pfx' => $this->data['config']['db-pfx'],
		   
		  ), false);
	}			
	}catch(\Exception $e){
		/* no explicit need of DB connection here */
	}
	 
		foreach($processors as $cmdpfx => $console){
			$t = $console['cli.cmd.cli'];
		
			$l = strlen($t);
			if(substr($cmd, 0, $l) === $t){
				$cmd = substr($cmd, $l, strlen($cmd));
				if(is_subclass_of($console['cli.class'], $console['cli.class.required.parent'])
				 && is_subclass_of($console['cli.class'], '\frdl\aSQL\Engines\Terminal\CLI')){
				try{
				   $this->Console = new $console['cli.class'];
				   $this->Console->applyApp($this);
				  
				  
				   $this->Console->exe($cmd);
				   $r = $this->Console->dump();
				   if(true===$mulitMode){
				   	   array_push($result, $r);
				   }else{
				   	   $result=$r;
				   }					
				}catch(\Exception $e){
				  if(null!==$eLevel)trigger_error('[#'.$i.'] '. $e->getMessage(), $eLevel);
				  array_push($errorlog, '[#'.$i.'] '.$e->getMessage());
				  if(true===$mulitMode){
				   	   array_push($result, null);
				   }else{
				   	   $result=null;
				   }	
				}	

			
				}else{
				  $msg='[#'.$i.'] '.'No valid Console SubClass: '.print_r($console, true);
				  if(null!==$eLevel)trigger_error($msg, $eLevel);
  				  array_push($errorlog, $msg);
				  if(true===$mulitMode){
				   	   array_push($result, null);
				   }else{
				   	   $result=null;
				   }						
					
				}
				   
			}
			
			$i++;
		}
		

	  return $result;
	}
	
		

	public function _api_request_cmd($cmd){

	try{
	if(null === self::$_db){
		self::$_db =\frdl\DB::_(array(
		//self::$_db =  new \frdl\DB(array(
		   'driver' => $this->data['config']['db-driver'],
		   'host' => $this->data['config']['db-host'],
		   'dbname' => $this->data['config']['db-dbname'],
		   'user' => $this->data['config']['db-user'],
		   'password' => $this->data['config']['db-pwd'],
		   'pfx' => $this->data['config']['db-pfx'],
		   
		  ), false);
	}			
	}catch(\Exception $e){
		/* no explicit need of DB connection here */
	}

	
		 
		foreach($this->data['settings']->cli as $cmdpfx => $console){
			$t = $console['cli.cmd.cli'];
		
			$l = strlen($t);
			if(substr($cmd, 0, $l) === $t){
				$cmd = substr($cmd, $l, strlen($cmd));
				if(is_subclass_of($console['cli.class'], $console['cli.class.required.parent'])
				 && is_subclass_of($console['cli.class'], '\frdl\aSQL\Engines\Terminal\CLI')){
					
				   $this->Console = new $console['cli.class'];
				   $this->Console->applyApp($this);
				  
				  
				   $this->Console->exe($cmd);
				  return  $this->_api_response( $this->Console->dump() );
			
				}else{
					\webdof\wResponse::status(501);
					trigger_error('No valid Console SubClass.', E_USER_NOTICE);
					continue;
				}
				   
			}
		}
		
		
		 \webdof\wResponse::status(404);
		 die('API cli not found');
	}
	
	
	protected function _api_response($dump){
		 $this->data['data_out']->data = $dump;
		/* error when not buffering? die($dump->statusText);  */
		die();
	}
	
	
} 

 
 
 
  
 $fexe = new webfan(__FILE__, __COMPILER_HALT_OFFSET__);
 $fexe->run();


__halt_compiler();µConfig%json%config.json
{
	"PACKAGE" : "{___$PACKAGE___}",
	"VERSION" : "{___$VERSION___}",
	"OID" : "{___$OID___}",
	"PIN_HASH" : "{___$PIN_HASH___}",
	"ADMIN_PWD" : "{___$adminpwd_optional_HASH___}",
	"PIN" : "{___$PIN___}",
	"HOST" : "{___$HOST___}",
	"HOST_HASH" : "{___$HOST_HASH___}",
	"URL" : "{$__LOCATION___}",
	"DOWNLOADTIME" : "{___$DOWNLOADTIME___}",
	"INSTALLTIME" : "{___$INSTALLTIME___}",
	"UID" : "{___$UID___}",
	"UNAME" : "{___$UNAME___}",
	"REGISTERED" : "{___$REGISTERED___}",
	"LICENSEKEY" : "{___$LICENSEKEY___}",
	"LICENSESERIAL" : "{___$LICENSESERIAL___}",
	"SECRET" : "{___$SECRET___}",
	"SHAREDSECRET" : "{___$SHAREDSECRET___}",
	"REGISTRATIONKEY" : "{___$REGISTRATIONKEY___}"
}
µxTpl%%Main Template



{$___TPL_FRDL_WEBFAN_INSTALL_HTML___}







µxTpl%%404
<span style="color:red;">The requested content was not found!</span>
<br />
[ <a href="/">Go to startpage</a> ]
<br />
<script type="text/javascript">
$(document).ready(function(){
$.WebfanDesktop({});	
document.title = '404 - Not found';
 uhrTimer.add("Timer_" + window.location.href + "_notification_404", function(){
	  if('function' !== typeof $.notificationcenter.newAlert)return;	
	  uhrTimer.remove("Timer_" + window.location.href + "_notification_404");
  	 $.notificationcenter.newAlert("Der angeforderte Inhalt unter " + window.location.href + " wurde nicht gefunden!", "error", true, function(notif){
		   document.title = notif.text;
	   }, 
	   Guid.newGuid()
	  );
	 $.ApplicationComposerOpen({});
  }); 
});
</script>
